Index: tools/h5stat/h5stat.c
===================================================================
--- tools/h5stat/h5stat.c	(revision 18506)
+++ tools/h5stat/h5stat.c	(working copy)
@@ -97,8 +97,9 @@
 } iter_t;
 
 
-const char *progname = "h5stat";
-int               d_status = EXIT_SUCCESS;
+/*const char *progname = "h5stat";*/
+/*int               d_status = EXIT_SUCCESS;*/
+
 static int        display_all = TRUE;
 static int        display_file = FALSE;
 static int        display_file_metadata = FALSE;
@@ -723,11 +724,11 @@
     while ((opt = get_option(argc, argv, s_opts, l_opts)) != EOF) {
         switch ((char)opt) {
             case 'h':
-                usage(progname);
+                usage(h5tools_getprogname());
                 leave(EXIT_SUCCESS);
 
             case 'V':
-                print_version(progname);
+                print_version(h5tools_getprogname());
                 leave(EXIT_SUCCESS);
                 break;
 
@@ -781,15 +782,15 @@
                 break;
 
             default:
-                usage(progname);
+                usage(h5tools_getprogname());
                 leave(EXIT_FAILURE);
         } /* end switch */
     } /* end while */
 
     /* check for file name to be processed */
     if (argc <= opt_ind) {
-        error_msg(progname, "missing file name\n");
-        usage(progname);
+        error_msg(h5tools_getprogname(), "missing file name\n");
+        usage(h5tools_getprogname());
         leave(EXIT_FAILURE);
     } /* end if */
 
@@ -1323,6 +1324,9 @@
     struct handler_t   *hand;
     H5F_info_t      	finfo;
 
+	h5tools_setprogname("h5stat");
+	h5tools_setstatus(EXIT_SUCCESS);
+
     /* Disable error reporting */
     H5Eset_auto2(H5E_DEFAULT, NULL, NULL);
 
@@ -1330,7 +1334,7 @@
     h5tools_init();
     hand = parse_command_line (argc, argv);
     if(!hand) {
-        error_msg(progname, "unable to parse command line arguments \n");
+        error_msg(h5tools_getprogname(), "unable to parse command line arguments \n");
         leave(EXIT_FAILURE);
     } /* end if */
 
@@ -1340,7 +1344,7 @@
 
     fid = H5Fopen(fname, H5F_ACC_RDONLY, H5P_DEFAULT);
     if(fid < 0) {
-        error_msg(progname, "unable to open file \"%s\"\n", fname);
+        error_msg(h5tools_getprogname(), "unable to open file \"%s\"\n", fname);
         leave(EXIT_FAILURE);
     } /* end if */
 
@@ -1349,7 +1353,7 @@
 
     /* Get storge info for SOHM's btree/list/heap and superblock extension */
     if(H5Fget_info(fid, &finfo) < 0)
-	warn_msg(progname, "Unable to retrieve SOHM info\n");
+	warn_msg(h5tools_getprogname(), "Unable to retrieve SOHM info\n");
     else {
 	iter.super_ext_size = finfo.super_ext_size;
 	iter.SM_hdr_storage_size = finfo.sohm.hdr_size;
@@ -1358,10 +1362,10 @@
     } /* end else */
 
     if((fcpl = H5Fget_create_plist(fid)) < 0)
-        warn_msg(progname, "Unable to retrieve file creation property\n");
+        warn_msg(h5tools_getprogname(), "Unable to retrieve file creation property\n");
 
     if(H5Pget_userblock(fcpl, &iter.ublk_size) < 0)
-        warn_msg(progname, "Unable to retrieve userblock size\n");
+        warn_msg(h5tools_getprogname(), "Unable to retrieve userblock size\n");
 
     /* Walk the objects or all file */
     if(display_object) {
@@ -1370,7 +1374,7 @@
         u = 0;
         while(hand[u].obj) {
             if (h5trav_visit(fid, hand[u].obj, TRUE, TRUE, obj_stats, lnk_stats, &iter) < 0)
-		warn_msg(progname, "Unable to traverse object \"%s\"\n", hand[u].obj);
+		warn_msg(h5tools_getprogname(), "Unable to traverse object \"%s\"\n", hand[u].obj);
 	    else
 		print_statistics(hand[u].obj, &iter);
             u++;
@@ -1378,7 +1382,7 @@
     } /* end if */
     else {
         if (h5trav_visit(fid, "/", TRUE, TRUE, obj_stats, lnk_stats, &iter) < 0)
-	    warn_msg(progname, "Unable to traverse objects/links in file \"%s\"\n", fname);
+	    warn_msg(h5tools_getprogname(), "Unable to traverse objects/links in file \"%s\"\n", fname);
 	else
 	    print_statistics("/", &iter);
     } /* end else */
@@ -1386,7 +1390,7 @@
     if (hand) free(hand);
 
     if(H5Fclose(fid) < 0) {
-        error_msg(progname, "unable to close file \"%s\"\n", fname);
+        error_msg(h5tools_getprogname(), "unable to close file \"%s\"\n", fname);
         leave(EXIT_FAILURE);
     }
 
Index: tools/h5ls/h5ls.c
===================================================================
--- tools/h5ls/h5ls.c	(revision 18506)
+++ tools/h5ls/h5ls.c	(working copy)
@@ -29,6 +29,8 @@
 #include "h5tools_utils.h"
 #include "h5trav.h"
 
+#include "h5tools_ref.h"
+
 #define NAME_BUF_SIZE   2048
 
 /* Struct to keep track of external link targets visited */
@@ -88,8 +90,6 @@
 static void display_type(hid_t type, int ind);
 static herr_t visit_obj(hid_t file, const char *oname, iter_t *iter);
 
-const char *progname="h5ls";
-int   d_status;
 
 
 /*-------------------------------------------------------------------------
@@ -135,7 +135,7 @@
       within the file then the contents of the root group are displayed).\n\
       The file name may include a printf(3C) integer format such as\n\
       \"%%05d\" to open a file family.\n",
-     progname);
+	    h5tools_getprogname() );
 }
 
 
@@ -2179,8 +2179,10 @@
     int  argno;
     static char root_name[] = "/";
     char        drivername[50];
-    const char *preferred_driver = NULL;
+    const char *preferred_driver = NULL; 
 
+	    h5tools_setprogname("h5ls");
+
     /* Initialize h5tools lib */
     h5tools_init();
 
@@ -2248,7 +2250,7 @@
         } else if(!HDstrcmp(argv[argno], "--verbose")) {
             verbose_g++;
         } else if(!HDstrcmp(argv[argno], "--version")) {
-            print_version(progname);
+		print_version(h5tools_getprogname() );
             leave(EXIT_SUCCESS);
         } else if(!HDstrcmp(argv[argno], "--hexdump")) {
             hexdump_g = TRUE;
@@ -2324,7 +2326,7 @@
                         break;
 
                     case 'V': /* --version */
-                        print_version(progname);
+			    print_version(h5tools_getprogname() );
                         leave(EXIT_SUCCESS);
 
                     case 'x': /* --hexdump */
@@ -2479,5 +2481,6 @@
     } /* end while */
 
     leave(EXIT_SUCCESS);
+    return 0;
 } /* end main() */
 
